-- excaver.lua
-- Created on:  2020-10-17
-- Author:      Rétro
--
-- API d'excavation de terrain

---
-- \class Bucheron RSI
local RSI_Excavatrice = {}
RSI_Excavatrice.__index = RSI_Excavatrice

rsiT = require("rsiTurtle")

---
-- \brief Constructeur de RSI_Bucheron
function RSI_Excavatrice:init()
    local excavatrice = {}
    setmetatable(excavatrice,RSI_Excavatrice)

    ---
    -- \brief Objet parent
    excavatrice.base_ = rsiT:init()

    return excavatrice
end


---
-- \brief Affiche la position et l'orientation de l'excavatrice
function RSI_Excavatrice:print()
    print("Type excavatrice.")
    self.base_:print()
end


---
-- \brief Dégager la zone vers le bas
-- \param int lines     Nombre de lignes
-- \param int cols      Nombre de colonnes
-- \param int depth     Profondeur z (vers le bas) sur laquelle excaver
-- \return bool Succès
function RSI_Excavatrice:excavateVolumeDown(lines, cols, depth)
    --TODO: Refuel quand < 100
    --TODO: Vider l'inventaire quand on a ramassé un truc et qu'il n'y a plus
    --      de cases libres
    return self.base_:goThroughVolume(lines, cols, depth, turtle.digDown)
end

return RSI_Excavatrice
